package
{
	import flash.events.MouseEvent;
	import flash.utils.setTimeout;
	
	import mx.controls.Image;
	import mx.core.Application;
	import mx.effects.Move;
	import mx.effects.Parallel;
	import mx.effects.Rotate;

	public class Card extends Image
	{
		public var value:int=0;
		public var string:String;
		public var numero:int = 0;
		public var source2:Object;
		public var isOnBack:Boolean = false;
		public var canTurn:Boolean = true;
		public var toBeChanged:Boolean = false;
		public var mine:Boolean = false;
		public var swfSource:String;
		public var chaine:String;
		
		
		public function change(newChaine:String ):void {
			this.moveToDeck();
			setTimeout(changeContinue,1000);
			function changeContinue():void {
				chaine = newChaine;
				swfSource= "assets/cards/" + chaine + ".swf";
				source = swfSource;
				source2 = swfSource;
	
				this.toBeChanged = false;
				this.isOnBack = false;
				this.canTurn = false;

				this.x = Application.application.deck.x;
				this.y = Application.application.deck.y;
				moveFromDeck();
			}
			
		}
		
		public function Card(chaine:String , numero:int , mine:Boolean, add:Boolean = true):void {
			super();

			this.chaine = chaine;
			this.swfSource= "assets/cards/" + chaine + ".swf";
			this.numero = numero;
			this.source = this.swfSource;
			this.source2 = this.swfSource;			
	
			this.toBeChanged = false;
			this.isOnBack = false;
			this.canTurn = mine;
			this.mine = mine;
			this.visible = true;
			if (mine) {
				this.buttonMode = true;
				this.addEventListener(MouseEvent.CLICK, cardClicked);
			}
			addToTable(add);

		}
public function addToTable(add:Boolean=true):void {
	if (add) {	
		Application.application.table.addChild(this);	
		this.x = Application.application.deck.x;
		this.y = Application.application.deck.y;
		}	
}		
		
public function cardClicked(e:MouseEvent):void {
	if (!this.canTurn) return;
	var numero:int = this.numero;
	this.isOnBack = !this.isOnBack;
	
	if (!this.isOnBack) {
		this.source = this.source2;
		Application.application.game.cardsToBeChanged.splice(Application.application.game.cardsToBeChanged.indexOf(this.numero),1);
		if (this.mine) this.toBeChanged = false;
	} else {
		this.source = Application.application.deck.source;
		Application.application.game.cardsToBeChanged.push(this.numero);
		if (this.mine) this.toBeChanged = true;
	}
}		
	public function show(chaine:String):void {
		this.chaine = chaine;
		this.swfSource= "assets/cards/" + chaine + ".swf";
		this.source = this.swfSource;
		this.source2 = this.swfSource;	
		this.isOnBack = false;
		this.canTurn = false;
					
	}

		public function reveal():void {
			this.isOnBack = false;
			this.canTurn = false;
			this.source = source2;			
		}
		public function hide():void {
			this.isOnBack = true;
			this.canTurn = true;
			this.source = Application.application.deck.source;		
		}		
		
		public function moveFromDeck():void {
			var par:Parallel = new Parallel(this);	
			var move:Move = new Move();
			var rotate:Rotate = new Rotate();
			rotate.duration = 500;
			move.duration = 500;
			par.addChild(move);
			par.addChild(rotate);	

			move.xFrom = Application.application.deck.x;
			move.yFrom = Application.application.deck.y;
			if (this.numero==1 && this.mine) {
				move.xTo = Application.application.mycard1.x;
				move.yTo = Application.application.mycard1.y;
			}
			if (this.numero==2 && this.mine) {
				move.xTo = Application.application.mycard2.x;
				move.yTo = Application.application.mycard2.y;
			}
			if (this.numero==3 && this.mine) {
				move.xTo = Application.application.mycard3.x;
				move.yTo = Application.application.mycard3.y;
			}
			if (this.numero==4 && this.mine) {
				move.xTo = Application.application.mycard4.x;
				move.yTo = Application.application.mycard4.y;
			}
			if (this.numero==5 && this.mine) {
				move.xTo = Application.application.mycard5.x;
				move.yTo = Application.application.mycard5.y;
			}	
			// his cards
			
			if (this.numero==1 && !this.mine) {
				move.xTo = Application.application.hiscard1.x;
				move.yTo = Application.application.hiscard1.y;
			}
			if (this.numero==2 && !this.mine) {
				move.xTo = Application.application.hiscard2.x;
				move.yTo = Application.application.hiscard2.y;
			}
			if (this.numero==3 && !this.mine) {
				move.xTo = Application.application.hiscard3.x;
				move.yTo = Application.application.hiscard3.y;
			}
			if (this.numero==4 && !this.mine) {
				move.xTo = Application.application.hiscard4.x;
				move.yTo = Application.application.hiscard4.y;
			}
			if (this.numero==5 && !this.mine) {
				move.xTo = Application.application.hiscard5.x;
				move.yTo = Application.application.hiscard5.y;
			}			
										
			par.play();
		}
		public function moveToDeck():void {
			var move:Move = new Move();
			move.target = this;
			move.xFrom = this.x;
			move.yFrom = this.y;
			move.xTo = Application.application.deck.x;
			move.yTo = Application.application.deck.y;
			move.play();			
		}
		public function turn():void {
			isOnBack=!isOnBack;
			if (isOnBack) {
				this.source = Application.application.deck.source
			} else {
				this.source = this.source2;
			}
		}

		
		
	}
}